from typing import Union, List, Optional

from pyspark.sql.types import StructType, StringType, DataType


# This file is auto-generated by generate_schema so do not edit manually
# noinspection PyPep8Naming
class markdownSchema:
    """
    A string that may contain markdown syntax for optional processing by a mark
    down presentation engine
    Systems are not required to have markdown support, and there is considerable
    variation in markdown syntax, so the text should be readable without markdown
    processing. The preferred markdown syntax is described here:
    http://daringfireball.net/projects/markdown/syntax (and tests here:
    http://daringfireball.net/projects/downloads/MarkdownTest_1.0.zip)
    If the element is present, it must have either a @value, an @id referenced
    from the Narrative, or extensions
    """

    # noinspection PyDefaultArgument
    @staticmethod
    def get_schema(
        max_nesting_depth: Optional[int] = 6,
        nesting_depth: int = 0,
        nesting_list: List[str] = [],
        max_recursion_limit: Optional[int] = 2,
        include_extension: Optional[bool] = False,
        extension_fields: Optional[List[str]] = [
            "valueBoolean",
            "valueCode",
            "valueDate",
            "valueDateTime",
            "valueDecimal",
            "valueId",
            "valueInteger",
            "valuePositiveInt",
            "valueString",
            "valueTime",
            "valueUnsignedInt",
            "valueUri",
            "valueQuantity",
        ],
        extension_depth: int = 0,
        max_extension_depth: Optional[int] = 2,
    ) -> Union[StructType, DataType]:
        """
        A string that may contain markdown syntax for optional processing by a mark
        down presentation engine
        Systems are not required to have markdown support, and there is considerable
        variation in markdown syntax, so the text should be readable without markdown
        processing. The preferred markdown syntax is described here:
        http://daringfireball.net/projects/markdown/syntax (and tests here:
        http://daringfireball.net/projects/downloads/MarkdownTest_1.0.zip)
        If the element is present, it must have either a @value, an @id referenced
        from the Narrative, or extensions


        """
        return StringType()
